// import { _decorator,log, gfx, postProcess, Material, EffectAsset, renderer, rendering, Vec4 } from 'cc';
// const { Format  } = gfx

// const { ccclass, property, menu, executeInEditMode } = _decorator;

// @ccclass('GaussianBlur')
// @menu('PostProcess/GaussianBlur')
// @executeInEditMode
// export class GaussianBlur extends postProcess.PostProcessSetting{

//     @property(EffectAsset)
//     _effectAsset: EffectAsset | undefined

//     @property(EffectAsset)
//     get effect () {
//         return this._effectAsset;
//     }
//     set effect (v) {
//         this._effectAsset = v;
//         if(this._effectAsset == null){
//             this._material = null;
//         }
//         else{
//             if(this._material == null){
//                 this._material = new Material();
//             }
//             this._material.reset({effectAsset:this._effectAsset});
//         }
//         this.updateMaterial();
//     }
    
//     @property
//     iterations = 3;

//     @property
//     get blurRadius(){
//         return this._blurParams.x;
//     }
//     set blurRadius(v){
//         this._blurParams.x = v;
//         this.updateMaterial();
//     }


//     private _material:Material;
//     public get material():Material{
//         return this._material;
//     }

//     @property
//     private _blurParams:Vec4 = new Vec4(1.0,0.0,0.0,0.0);
//     public get blurParams():Vec4{
//         return this._blurParams;
//     }

//     updateMaterial(){
//         if(!this._material){
//             return;
//         }
//         this._material.setProperty('blurParams', this.blurParams);
//     }
//     protected onDestroy(): void 
//     {
//         const builder = rendering.getCustomPipeline('Custom') as postProcess.PostProcessBuilder;
//         if (builder) 
//         {
//             const pp = builder.pipelines.get('forward');
//             if(pp)
//             {
//                 const oldIdx = pp.findIndex(function (p) {return p.name === 'GaussianBlurPass';});
//                 if (oldIdx !== -1) 
//                 {
//                     pp.splice(oldIdx, 1);
//                 }
//             }

//         }
//         if(this._material)
//         {
//             this._material.destroy();
//             this._material = undefined;            
//         }
//     }

//     protected __preload(): void 
//     {
//         const builder = rendering.getCustomPipeline('Custom') as postProcess.PostProcessBuilder;
//         if (builder) 
//         {
//             // this._pBlitScreenPass = builder.getPass(postProcess.BlitScreenPass);
//             builder.insertPass(new GaussianBlurPass(),postProcess.BlitScreenPass);
//         }
//         if(this._effectAsset)
//         {
//             // this._material = new Material();
//             // this._material.initialize({effectAsset:this._effectAsset});
//             this._material = new Material();
//             this._material.initialize({effectAsset:this._effectAsset});
//             this._material.setProperty('blurParams', this.blurParams);
//         }
//     }

//     // protected start(): void {
//     //     if(this._effectAsset){
//     //         this._material = new Material();
//     //         this._material.initialize({effectAsset:this._effectAsset});
//     //         this._material.setProperty('blurParams', this.blurParams);
//     //     }
//     // }
// }

// class GaussianBlurPass extends postProcess.SettingPass {
//     get setting () 
//     { 
//         return this.getSetting(GaussianBlur); 
//     }

//     checkEnable (camera: renderer.scene.Camera) {
//         let enable = super.checkEnable(camera);
//         if (postProcess.disablePostProcessForDebugView()) {
//             enable = false;
//         }
//         return enable && this.setting.material != null;
//     }

//     name = 'GaussianBlurPass';
//     outputNames = ['GaussianBlurMap'];

//     public render (camera: renderer.scene.Camera, ppl: rendering.Pipeline): void {
//         const setting = this.setting;
//         if(!setting.material){
//             return;
//         }

//         let passContext = this.context;
//         passContext.material = setting.material;

//         const cameraID = this.getCameraUniqueID(camera);
//         const cameraName = `Camera${cameraID}`;
//         const passViewport = passContext.passViewport;

//         passContext.clearBlack();
//         const format = Format.RGBA8;

//         let input = this.lastPass!.slotName(camera, 0);
//         for(let i = 0; i < setting.iterations; ++i){
//             passContext
//                 .updatePassViewPort()
//                 .addRenderPass(`blur-x`, `blur-x${cameraID}`)
//                 .setPassInput(input, 'outputResultMap')
//                 .addRasterView('GaussianBlurMap_TMP', format)
//                 .blitScreen(0)
//                 .version();

//             passContext
//                 .updatePassViewPort()
//                 .addRenderPass(`blur-y`, `blur-y${cameraID}`)
//                 .setPassInput('GaussianBlurMap_TMP', 'outputResultMap')
//                 .addRasterView(this.slotName(camera), format)
//                 .blitScreen(1)
//                 .version();
//             input = this.slotName(camera);
//         }
//     }
// }

// const builder = rendering.getCustomPipeline('Custom') as postProcess.PostProcessBuilder;
// if (builder) {
//     builder.insertPass(new GaussianBlurPass(),postProcess.BlitScreenPass);
// }

import { _decorator,log,CCInteger,isValid, gfx, postProcess, Material, EffectAsset, renderer, rendering, Vec4 } from 'cc';
// import { _decorator,log, gfx, Component, Material, renderer, rendering, Vec4 } from 'cc';
const { Format  } = gfx

const { ccclass, property, type,menu, executeInEditMode,disallowMultiple } = _decorator;

class GaussianBlurPass extends postProcess.SettingPass 
{
    get setting () :GaussianBlur
    { 
        return this.getSetting(GaussianBlur); 
    }

    checkEnable (camera: renderer.scene.Camera) : boolean
    {
        let enable = super.checkEnable(camera);
        if (postProcess.disablePostProcessForDebugView()) 
        {
            enable = false;
        }
        return enable && this.setting.material != null;
    }

    name = 'GaussianBlurPass';
    outputNames = ['GaussianBlurMap'];

    public render (camera: renderer.scene.Camera, ppl: rendering.Pipeline): void 
    {
        const setting = this.setting;
        if(setting.material)
        {
            let passContext = this.context;
            passContext.material = setting.material;
    
            const cameraID = this.getCameraUniqueID(camera);
            // const cameraName = `Camera${cameraID}`;
            // const passViewport = passContext.passViewport;
    
            passContext.clearBlack();
            const format = Format.RGBA8;
    
            let input = this.lastPass!.slotName(camera, 0);
            for(let i = 0; i < setting.iterations; ++i)
            {
                passContext
                    .updatePassViewPort()
                    .addRenderPass(`blur-x`, `blur-x${cameraID}`)
                    .setPassInput(input, 'outputResultMap')
                    .addRasterView('GaussianBlurMap_TMP', format)
                    .blitScreen(0)
                    .version();
    
                passContext
                    .updatePassViewPort()
                    .addRenderPass(`blur-y`, `blur-y${cameraID}`)
                    .setPassInput('GaussianBlurMap_TMP', 'outputResultMap')
                    .addRasterView(this.slotName(camera), format)
                    .blitScreen(1)
                    .version();
                input = this.slotName(camera);
            }
        }
    }
}


@ccclass('GaussianBlur')
@menu('PostProcess/GaussianBlur')
@disallowMultiple
@executeInEditMode
export class GaussianBlur extends postProcess.PostProcessSetting
{

    private static gGaussianBlurPass:GaussianBlurPass = new GaussianBlurPass();

    @property({ type: Material ,serializable:true,visible: false}) 
    private _material:Material;
    @type(Material)
    set material(v:Material)
    {
        if(this._material)
        {
            this._material.destroy();
        }

        this._material = v;
        this.updateMaterial();
    }
    get material():Material
    {
        return this._material;
    }
    
    // @property(EffectAsset)
    // _effectAsset: EffectAsset;
    // @property(EffectAsset)
    // get effect () 
    // {
    //     return this._effectAsset;
    // }
    // set effect (v) 
    // {
    //     this._effectAsset = v;
        
    //     if(this._material)
    //     {

    //     }
    //     if(this._effectAsset == null)
    //     {
    //         this._material = null;
    //     }
    //     else
    //     {
    //         if(this._material == null)
    //         {
    //             this._material = new Material();
    //         }
    //         this._material.reset({effectAsset:this._effectAsset});
    //     }
    //     this.updateMaterial();
    // }
    
    @property({ type: CCInteger ,serializable:true,visible: false}) 
    private _iterations = 3;
    @type(CCInteger)
    get iterations()
    {
        return this._iterations;
    }
    set iterations(v)
    {
        this._iterations = v;
    }

    @type(CCInteger)
    get blurRadius()
    {
        return this._blurParams.x;
    }
    set blurRadius(v)
    {
        const temp = Math.floor(v);
        if(temp != this._blurParams.x)
        {
            this._blurParams.x = temp;
            this.updateMaterial();
        }
    }

    @property
    private _blurParams:Vec4 = new Vec4(1.0,0.0,0.0,0.0);

    public get blurParams():Vec4
    {
        return this._blurParams;
    }

    updateMaterial()
    {
        if(this._material)
        {
            this._material.setProperty('blurParams', this.blurParams);
        }
    }

    protected onDestroy(): void 
    {
        // const builder = rendering.getCustomPipeline('Custom') as postProcess.PostProcessBuilder;
        // if (builder) 
        // {
        //     const pp = builder.pipelines.get('forward');
        //     if(pp)
        //     {
        //         const oldIdx = pp.findIndex(function (p) {return p.name === 'GaussianBlurPass';});
        //         if (oldIdx !== -1) 
        //         {
        //             pp.splice(oldIdx, 1);
        //         }
        //     }
        // }

        if(this._material)
        {
            // this._material.destroy();
            this._material = undefined;            
        }
    }

    protected __preload(): void 
    {
        if(this._material)
        {
            // const builder = rendering.getCustomPipeline('Custom') as postProcess.PostProcessBuilder;
            // if (builder) 
            // {
            //     builder.insertPass(GaussianBlur.gGaussianBlurPass,postProcess.BlitScreenPass);
            // }
            // // this._material = new Material();
            // // this._material.initialize({effectAsset:this._effectAsset});
            // this._material.setProperty('blurParams', this.blurParams);
        }
    }
}